/*  b_function_4.c */

/*
  bؿκˤwavեκ

  16bit	ƥ쥪  ץǡ

  -54*z^3+(-36*x*y-8*x^3)*z^2+4*y^3*z

  [[-1,1],[s+1,3],[3*s+2,2],[3*s+4,2],[6*s+5,1],[6*s+7,1]]



*/

#include	<stdio.h>
#include	<math.h>

typedef	struct	tagWaveHeaderType	{
  char	cRiffHeader[4];
  long	nFileSize;
  char	cWaveHeader[4];
  char	cFmtChunk[4];
  long	nChunkSize;
  short	nFmtID;
  short	nCh;
  long	nRate;
  long	nSpeed;
  short	nBlockSize;
  short	nBitsParSample;
  char	cDataChunk[4];
  long	nDataBytes;
}	WaveHeaderType, * LpWaveHeaderType;


void	InitHeader( LpWaveHeaderType p )
{
  p->cRiffHeader[0] = 'R';
  p->cRiffHeader[1] = 'I';
  p->cRiffHeader[2] = 'F';
  p->cRiffHeader[3] = 'F';
	
  p->nFileSize = 0;	/*	ե륵ʸǷ׻	*/
	
  p->cWaveHeader[0] = 'W';
  p->cWaveHeader[1] = 'A';
  p->cWaveHeader[2] = 'V';
  p->cWaveHeader[3] = 'E';
	
  p->cFmtChunk[0] = 'f';
  p->cFmtChunk[1] = 'm';
  p->cFmtChunk[2] = 't';
  p->cFmtChunk[3] = ' ';
	
  p->nChunkSize = 16;
	
  p->nFmtID = 1;	/*	˥PCMʲϿ	*/
	
  p->nCh = 2;		/*	ƥ쥪	*/
  p->nRate = 44100;	/*	ץ󥰼ȿ
						ñ̻Υǡκμ	*/
  p->nSpeed = 176400;	/*	ʿѥǡ®	*/
  p->nBlockSize = 4;	/*	֥å	*/
  p->nBitsParSample = 16;	/*	̻Ҳӥåȿ	*/
	
  p->cDataChunk[0] = 'd';
  p->cDataChunk[1] = 'a';
  p->cDataChunk[2] = 't';
  p->cDataChunk[3] = 'a';
       
  p->nDataBytes = 176400L*7L;	/*	ǡ	*/
	
  p->nFileSize = p->nDataBytes + 44L - 8L;	/*	ե륵	*/
}

unsigned char b_function( int i, double a, double b, double s );


int main()
{
  WaveHeaderType	h;
  int		i, j;
  long	x;
  char	c;
  FILE*	fp;

  double s1 = -1.0000;    /* bؿκ */
  double s2 = -0.6666; 
  double s3 = -1.3333;
  double s4 = -0.8333;
  double s5 = -1.1666;

  double a1 = 12.301;     /* ܲʬʬۡʰʲŬ*/
  double b1 = 6.156;
  double a2 = -12.077;
  double b2 = 5.536;
  double a3 = -10.00;
  double b3 = 8.025;
  double a4 = -13.077;
  double b4 = 2.134;
  double a5 = -12.212;
  double b5 = -15.035;
	
  fp = fopen( "b_function_4.wav", "wb" );
	
  InitHeader( &h );
	
  fwrite( &h, sizeof(h), 1, fp );
	

  /* 7 */
  for( i = 0; i < 176400*1; i++ ) {
	c = b_function( i, a1, b1, s1);
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*1; i < 176400*2; i++ ){
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*2; i < 176400*3; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*3; i < 176400*4; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*4; i < 176400*7; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 ) 
	  + b_function( i, a5, b5, s5 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
	
  fclose( fp );

  return 0 ;
}

unsigned char b_function( int i, double a, double b, double s)
{
  int n;
  unsigned char f = 0;
  int v = 5000;           /* Ȥ® */
    

  f = a * sin( s * (double)(i / 176400.0) * v ) 
	+ b * cos( s * (double)(i / 176400.0) * v );

  return f;
}


/* b_function_4.c  end */
