/*  legendre_1.c */

/*
  Legendre¿༰ˤwavեκ
  P[1,x] = x

  16bit	ƥ쥪  ץǡ
*/

#include	<stdio.h>
#include	<math.h>

typedef	struct	tagWaveHeaderType	{
  char	cRiffHeader[4];
  long	nFileSize;
  char	cWaveHeader[4];
  char	cFmtChunk[4];
  long	nChunkSize;
  short	nFmtID;
  short	nCh;
  long	nRate;
  long	nSpeed;
  short	nBlockSize;
  short	nBitsParSample;
  char	cDataChunk[4];
  long	nDataBytes;
}	WaveHeaderType, * LpWaveHeaderType;


void	InitHeader( LpWaveHeaderType p )
{
  p->cRiffHeader[0] = 'R';
  p->cRiffHeader[1] = 'I';
  p->cRiffHeader[2] = 'F';
  p->cRiffHeader[3] = 'F';
	
  p->nFileSize = 0;	/*	ե륵ʸǷ׻	*/
	
  p->cWaveHeader[0] = 'W';
  p->cWaveHeader[1] = 'A';
  p->cWaveHeader[2] = 'V';
  p->cWaveHeader[3] = 'E';
	
  p->cFmtChunk[0] = 'f';
  p->cFmtChunk[1] = 'm';
  p->cFmtChunk[2] = 't';
  p->cFmtChunk[3] = ' ';
	
  p->nChunkSize = 16;
	
  p->nFmtID = 1;	/*	˥PCMʲϿ	*/
	
  p->nCh = 2;		/*	ƥ쥪	*/
  p->nRate = 44100;	/*	ץ󥰼ȿ
						ñ̻Υǡκμ	*/
  p->nSpeed = 176400;	/*	ʿѥǡ®	*/
  p->nBlockSize = 4;	/*	֥å	*/
  p->nBitsParSample = 16;	/*	̻Ҳӥåȿ	*/
	
  p->cDataChunk[0] = 'd';
  p->cDataChunk[1] = 'a';
  p->cDataChunk[2] = 't';
  p->cDataChunk[3] = 'a';
       
  p->nDataBytes = 176400L*3L;	/*	ǡ	*/
	
  p->nFileSize = p->nDataBytes + 44L - 8L;	/*	ե륵	*/
}

unsigned char legendre( int i, double a, int n );


int		main()
{
  WaveHeaderType	h;
  int		i;
  char	c;
  FILE*	fp;

  int n1 = 1;    /* legendre¿༰˴ޤޤμ */
 

  double a1 = 1.0000;     /* legendre¿༰η*/


  fp = fopen( "legendre_1.wav", "wb" );
	
  InitHeader( &h );
	
  fwrite( &h, sizeof(h), 1, fp );
	

  /* 3 */
  for( i = 0; i < 176400*3; i++ ) {
	c = legendre( i, a1, n1);
	fwrite( &c, sizeof(c), 1, fp );	
  }
  fclose( fp );

  return 0 ;
}

unsigned char legendre( int i, double a, int n)
{
  unsigned char f = 0;
  int v = 3000;           /* Ȥ®١Ŭ */
    

  f = 10*(a * sin( n * (double)(i / 176400.0) * v ) 
		  + a * cos( n * (double)(i / 176400.0) * v ));

  return f;
}


/* legendre_1.c  end */
